/*
 * The MIT License
 *
 * Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
 *
 * Copyright (C) 2021 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
 *
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is furnished to do
 * so, subject to the following conditions:
 *
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
package dk.sundhedsdatastyrelsen.cbs.dao.impl.jdbc;

import dk.sundhedsdatastyrelsen.cbs.dao.NasLock;
import org.springframework.lang.NonNull;

import java.time.LocalDateTime;

public class NasLockImpl implements NasLock {

    @NonNull
    static final String TOPIC_COLUMN_LABEL = "TOPIC";
    @NonNull
    static final String LOCKED_UNTIL_COLUMN_LABEL = "LOCKED_UNTIL";

    private String topic;

    private LocalDateTime lockedUntil;

    @Override
    @NonNull
    public String topic() {
        return topic;
    }

    @Override
    @NonNull
    public LocalDateTime lockedUntil() {
        return lockedUntil;
    }

    @NonNull
    public NasLockImpl topic(@NonNull final String topic) {
        this.topic = topic;
        return this;
    }

    @NonNull
    public NasLockImpl lockedUntil(@NonNull final LocalDateTime lockedUntil) {
        this.lockedUntil = lockedUntil;
        return this;
    }

    public void setTopic(@NonNull final String topic) {
        this.topic = topic;
    }

    public void setLockedUntil(@NonNull final LocalDateTime lockedUntil) {
        this.lockedUntil = lockedUntil;
    }
}
