/*
 * The MIT License
 *
 * Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
 *
 * Copyright (C) 2021 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
 *
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is furnished to do
 * so, subject to the following conditions:
 *
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
///*
// * The MIT License
// *
// * Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
// *
// * Copyright (C) 2021 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
// *
// *
// * Permission is hereby granted, free of charge, to any person obtaining a copy of
// * this software and associated documentation files (the "Software"), to deal in
// * the Software without restriction, including without limitation the rights to
// * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
// * of the Software, and to permit persons to whom the Software is furnished to do
// * so, subject to the following conditions:
// *
// *
// * The above copyright notice and this permission notice shall be included in all
// * copies or substantial portions of the Software.
// *
// *
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// */
//package dk.sundhedsdatastyrelsen.cbs.dao.impl.jdbc;
//
//import com.sun.istack.internal.NotNull;
//import dk.sundhedsdatastyrelsen.fluent.spring.jdbc.Mapper;
//import dk.sundhedsdatastyrelsen.fluent.spring.jdbc.UUIDs;
//import org.apache.commons.io.IOUtils;
//import org.junit.jupiter.api.BeforeAll;
//import org.junit.jupiter.api.DisplayName;
//import org.junit.jupiter.params.ParameterizedTest;
//import org.junit.jupiter.params.provider.Arguments;
//import org.junit.jupiter.params.provider.MethodSource;
//import org.springframework.jdbc.core.namedparam.SqlParameterSource;
//import org.springframework.jdbc.core.support.SqlLobValue;
//import org.springframework.lang.NonNull;
//
//import java.io.IOException;
//import java.io.Reader;
//import java.io.StringReader;
//import java.lang.reflect.Field;
//import java.sql.ResultSet;
//import java.sql.SQLException;
//import java.sql.Timestamp;
//import java.time.LocalDateTime;
//import java.util.Arrays;
//import java.util.UUID;
//import java.util.function.Supplier;
//import java.util.stream.Stream;
//
//import static dk.sundhedsdatastyrelsen.cbs.dao.impl.jdbc.RecordImpl.CREATION_TIME_COLUMN_LABEL;
//import static dk.sundhedsdatastyrelsen.cbs.dao.impl.jdbc.RecordImpl.DATA_COLUMN_LABEL;
//import static dk.sundhedsdatastyrelsen.cbs.dao.impl.jdbc.RecordImpl.INVALIDATION_TIME_COLUMN_LABEL;
//import static dk.sundhedsdatastyrelsen.cbs.dao.impl.jdbc.RecordImpl.KEY_COLUMN_LABEL;
//import static dk.sundhedsdatastyrelsen.cbs.dao.impl.jdbc.RecordImpl.SOURCE_COLUMN_LABEL;
//import static dk.sundhedsdatastyrelsen.cbs.dao.impl.jdbc.RecordImpl.TRACE_ID_COLUMN_LABEL;
//import static dk.sundhedsdatastyrelsen.cbs.dao.impl.jdbc.RecordMappers.mapper;
//import static java.nio.charset.StandardCharsets.UTF_8;
//import static org.junit.jupiter.api.Assertions.assertArrayEquals;
//import static org.junit.jupiter.api.Assertions.assertEquals;
//import static org.junit.jupiter.api.Assertions.assertNotNull;
//import static org.mockito.Mockito.mock;
//import static org.mockito.Mockito.when;
//
//class RecordMappersTest {
//
//    private static Field contentField;
//
//    @BeforeAll
//    static void setup() throws NoSuchFieldException {
//        contentField = SqlLobValue.class.getDeclaredField("content");
//        contentField.setAccessible(true);
//    }
//
//    @DisplayName("read / write")
//    @ParameterizedTest
//    @MethodSource("constructors")
//    <V extends RecordImpl<String, String, V>> void test(Supplier<V> constructor) throws SQLException, IllegalAccessException {
//        final UUID key = UUID.randomUUID();
//        final byte[] keyBytes = UUIDs.toBytes(key);
//        final LocalDateTime creationTime = LocalDateTime.now();
//        final LocalDateTime invalidationTime = LocalDateTime.now();
//        final String schemaName = "SCHEMA";
//        final String tableName = "TABLE";
//        final String traceId = "TRACE_ID";
//        final String data = "DATA";
//        final String source = "SOURCE";
//
//        final ResultSet resultSet = mock(ResultSet.class);
//        when(resultSet.getBytes(KEY_COLUMN_LABEL)).thenReturn(UUIDs.toBytes(key));
//        when(resultSet.getString(TRACE_ID_COLUMN_LABEL)).thenReturn(traceId);
//        when(resultSet.getTimestamp(CREATION_TIME_COLUMN_LABEL)).thenReturn(Timestamp.valueOf(creationTime));
//        when(resultSet.getTimestamp(INVALIDATION_TIME_COLUMN_LABEL)).thenReturn(Timestamp.valueOf(invalidationTime));
//        when(resultSet.getCharacterStream(DATA_COLUMN_LABEL)).thenReturn(new StringReader(data));
//        when(resultSet.getCharacterStream(SOURCE_COLUMN_LABEL)).thenReturn(new StringReader(source));
//
//        final Mapper<V> mapper = mapper(
//            schemaName,
//            tableName,
//            constructor,
//            RecordMappersTest::toString,
//            RecordMappersTest::toBytes,
//            RecordMappersTest::toString,
//            RecordMappersTest::toBytes)
//            .build();
//
//        final V record = mapper.mapRow(resultSet, 0);
//
//        assertNotNull(record);
//        assertEquals(key, record.key());
//        assertEquals(traceId, record.traceId());
//        assertEquals(creationTime, record.creationTime());
//        assertEquals(invalidationTime, record.invalidationTime());
//        assertEquals(data, record.data());
//        assertEquals(source, record.source());
//
//        final SqlParameterSource parameterSource = mapper.parameterSource(record);
//        assertNotNull(parameterSource);
//        assertArrayEquals(keyBytes, (byte[]) parameterSource.getValue(KEY_COLUMN_LABEL));
//        assertEquals(traceId, parameterSource.getValue(TRACE_ID_COLUMN_LABEL));
//        assertEquals(Timestamp.valueOf(creationTime), parameterSource.getValue(CREATION_TIME_COLUMN_LABEL));
//        assertEquals(Timestamp.valueOf(invalidationTime), parameterSource.getValue(INVALIDATION_TIME_COLUMN_LABEL));
//        assertEquals(data, toString((SqlLobValue) parameterSource.getValue(DATA_COLUMN_LABEL)));
//        assertEquals(source, toString((SqlLobValue) parameterSource.getValue(SOURCE_COLUMN_LABEL)));
//    }
//
//    @NonNull
//    private static String toString(@NotNull final SqlLobValue lob) throws IllegalAccessException {
//        return new String((byte[]) contentField.get(lob), UTF_8);
//    }
//
//    private static byte[] toBytes(String string) {
//        return string.getBytes(UTF_8);
//    }
//
//    private static String toString(Reader reader) {
//        try {
//            return IOUtils.toString(reader);
//        } catch (IOException e) {
//            throw new RuntimeException(e);
//        }
//    }
//
//    @NonNull
//    private static Stream<Arguments> constructors() {
//        final class A extends VaccinationRecordImpl<String, String> {}
//        final class B extends LabResultRecordImpl<String, String> {}
//        return Arrays.stream(new Supplier[] { A::new, B::new}).map(Arguments::arguments);
//    }
//}
