-- liquibase formatted sql
-- changeset nig@trifork.com:add-nas-tables

create or replace table nas_lock
(
    topic                      varchar(255)            not null comment 'NAS topic',
    locked_until               timestamp               not null comment 'Lock held at most until timestamp',
    constraint pk__nas primary key (topic) comment 'primary key constraint'
);

create or replace table nas_status
(
    topic                      varchar(255)            not null comment 'NAS topic',
    message_id                 binary(16)              not null comment 'Current message Id',
    constraint pk__nas primary key (topic) comment 'primary key constraint'
);

create or replace table nas_subscription
(
    topic                      varchar(255)            not null comment 'NAS topic',
    pull_point                 varchar(255)            not null comment 'PullPoint Reference',
    subscription               varchar(255)            not null comment 'Subscription Reference',
    constraint pk__nas primary key (topic) comment 'primary key constraint'
);
